/*
 * Person.java
 *
 * Created on July 25, 2006, 3:02 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ee5travel.entities;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;

/**
 *
 * @author craigmcc
 */
@Entity
@Table(name = "PERSON")
@NamedQueries( {@NamedQuery(name = "Person.findByPersonid", query = "SELECT p FROM Person p WHERE p.personid = :personid"), @NamedQuery(name = "Person.findByName", query = "SELECT p FROM Person p WHERE p.name = :name"), @NamedQuery(name = "Person.findByJobtitle", query = "SELECT p FROM Person p WHERE p.jobtitle = :jobtitle"), @NamedQuery(name = "Person.findByFrequentflyer", query = "SELECT p FROM Person p WHERE p.frequentflyer = :frequentflyer")})
public class Person implements Serializable {

    @Id
    @Column(name = "PERSONID", nullable = false)
    private Integer personid;

    @Column(name = "NAME")
    private String name;

    @Column(name = "JOBTITLE")
    private String jobtitle;

    @Column(name = "FREQUENTFLYER")
    private Short frequentflyer;

    @OneToMany(cascade = CascadeType.ALL, mappedBy = "personid")
    private java.util.Collection <ee5travel.entities.Trip> tripCollection;
    
    /** Creates a new instance of Person */
    public Person() {
    }

    public Person(Integer personid) {
        this.personid = personid;
    }

    public Integer getPersonid() {
        return this.personid;
    }

    public void setPersonid(Integer personid) {
        this.personid = personid;
    }

    public String getName() {
        return this.name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getJobtitle() {
        return this.jobtitle;
    }

    public void setJobtitle(String jobtitle) {
        this.jobtitle = jobtitle;
    }

    public Short getFrequentflyer() {
        return this.frequentflyer;
    }

    public void setFrequentflyer(Short frequentflyer) {
        this.frequentflyer = frequentflyer;
    }

    public java.util.Collection <ee5travel.entities.Trip> getTripCollection() {
        return this.tripCollection;
    }

    public void setTripCollection(java.util.Collection <ee5travel.entities.Trip> tripCollection) {
        this.tripCollection = tripCollection;
    }

    public int hashCode() {
        int hash = 0;
        hash += (this.personid != null ? this.personid.hashCode() : 0);
        return hash;
    }

    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Person)) {
            return false;
        }
        Person other = (Person)object;
        if (this.personid != other.personid && (this.personid == null || !this.personid.equals(other.personid))) return false;
        return true;
    }

    public String toString() {
        return "ee5travel.entities.Person[personid=" + personid + "]";
    }
    

    /**
     * <p>Manually added method to return a list of trips for this person
     * that JSF can bind to.</p>
     */
    public List<Trip> getTrips() {
        return new ArrayList<Trip>(getTripCollection());
    }


}
