/*
 * Trip.java
 *
 * Created on July 25, 2006, 3:01 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package ee5travel.entities;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.CascadeType;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 *
 * @author craigmcc
 */
@Entity
@Table(name = "TRIP")
@NamedQueries( {@NamedQuery(name = "Trip.findByTripid", query = "SELECT t FROM Trip t WHERE t.tripid = :tripid"), @NamedQuery(name = "Trip.findByDepdate", query = "SELECT t FROM Trip t WHERE t.depdate = :depdate"), @NamedQuery(name = "Trip.findByDepcity", query = "SELECT t FROM Trip t WHERE t.depcity = :depcity"), @NamedQuery(name = "Trip.findByDestcity", query = "SELECT t FROM Trip t WHERE t.destcity = :destcity")})
public class Trip implements Serializable {

    @Id
    @Column(name = "TRIPID", nullable = false)
    private Integer tripid;

    @Column(name = "DEPDATE")
    @Temporal(TemporalType.DATE)
    private Date depdate;

    @Column(name = "DEPCITY")
    private String depcity;

    @Column(name = "DESTCITY")
    private String destcity;

    @JoinColumn(name = "PERSONID", referencedColumnName = "PERSONID")
    @ManyToOne
    private ee5travel.entities.Person personid;

    @JoinColumn(name = "TRIPTYPEID", referencedColumnName = "TRIPTYPEID")
    @ManyToOne
    private ee5travel.entities.Triptype triptypeid;

    /** Creates a new instance of Trip */
    public Trip() {
    }

    public Trip(Integer tripid) {
        this.tripid = tripid;
    }

    public Integer getTripid() {
        return this.tripid;
    }

    public void setTripid(Integer tripid) {
        this.tripid = tripid;
    }

    public Date getDepdate() {
        return this.depdate;
    }

    public void setDepdate(Date depdate) {
        this.depdate = depdate;
    }

    public String getDepcity() {
        return this.depcity;
    }

    public void setDepcity(String depcity) {
        this.depcity = depcity;
    }

    public String getDestcity() {
        return this.destcity;
    }

    public void setDestcity(String destcity) {
        this.destcity = destcity;
    }

    public ee5travel.entities.Person getPersonid() {
        return this.personid;
    }

    public void setPersonid(ee5travel.entities.Person personid) {
        this.personid = personid;
    }

    public ee5travel.entities.Triptype getTriptypeid() {
        return this.triptypeid;
    }

    public void setTriptypeid(ee5travel.entities.Triptype triptypeid) {
        this.triptypeid = triptypeid;
    }

    public int hashCode() {
        int hash = 0;
        hash += (this.tripid != null ? this.tripid.hashCode() : 0);
        return hash;
    }

    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Trip)) {
            return false;
        }
        Trip other = (Trip)object;
        if (this.tripid != other.tripid && (this.tripid == null || !this.tripid.equals(other.tripid))) return false;
        return true;
    }

    public String toString() {
        return "ee5travel.entities.Trip[tripid=" + tripid + "]";
    }
    
}
